unit lockfile;

interface

procedure testlock;

implementation

uses
  SysUtils,OsDepend,resource,xp0;

var
  lockfName   : string;
  lockfHandle : integer;          { gelockte Datei LOCKFILE }

procedure testlock;
const
  LockString: String = 'Isn''t this a beautiful lockfile?';
var
  LockDenied: Boolean;
  i: integer;
begin
  if ParNolock then exit;
  LockDenied := false;
  lockfName := OwnPath + 'LOCKFILE';
  lockfHandle := FileCreate(lockfName, fmOpenWrite + fmShareDenyWrite);
  if (IOResult <> 0) or (lockfHandle < 0) then
    LockDenied := true
  else
  begin
    if (FileWrite(lockfHandle, LockString[1], Length(LockString)) < 0) then
      LockDenied := true
  end;
  if (IOResult <> 0) or LockDenied then
  begin
    writeln;
    for i:=1 to res2anz(244) do
      writeln(getres2(244,i));
    {$ifdef Unix}
    writeln;
    for i:=1 to res2anz(245) do
      writeln(getres2(245,i));
    {$endif}
    writeln;
    SysDelay(3000);
    FileClose(lockfHandle);
    DeleteFile(lockfName);
    runerror:=false;
    halt(1);
  end;
  lockopen:=true;
end;

initialization
  // testlock; !!! called from StartOpenXP in main.pas !!!

finalization
  if lockopen then
  begin
    FileClose(lockfHandle);
    DeleteFile(lockfName);
  end;

end.
