{$I xpdefine.inc}

unit ncresource;

interface

function res_connect1        : string;  { Versuche %s zu erreichen... }
function res_connect2        : string;  { Unerreichbar: %s }
function res_connect3        : string;  { Anmeldung fehlgeschlagen: %s }
function res_connect4        : string;  { Verbunden mit %s }
function res_disconnect      : string;  { Trenne Verbindung... }
function res_error           : string;  { Fehler: %s }
function res_noconnect       : string;  { Verbindungsaufbau fehlgeschlagen }
function res_userbreak       : string;  { Abbruch durch User }
function res_strange         : string;  { Interner Fehler:  }
function res_posterror       : string;  { Fehler %d beim Absenden der Nachricht }
function res_postmsg         : string;  { Verschicke Nachricht %d (gesamt %.0f%%) }
function res_auth            : string;  { Authentifikation benoetigt }
function res_list1           : string;  { Setze Lese-Modus... }
function res_list2           : string;  { Kann nicht mit %s kommunizieren! }
function res_list3           : string;  { %s gibt die Liste nicht frei! }
function res_list4           : string;  { %d Newsgroupnamen gelesen }
function res_list5           : string;  { Suche Beschreibung fuer %s... }
function res_groupnotfound   : string;  { Gruppe %s nicht gefunden }
function res_msg1            : string;  { hole Artikel %d, Zeile %d }
function res_msg2            : string;  { hole Header %d, Zeile %d }
function res_msg3            : string;  { Artikel %s nicht mehr auf Server vorhanden }
function res_msg4            : string;  { hole Message-ID %s, Zeile %d }
function res_getgrouplistinit: string;  { %s Newsgroupliste holen }
function res_postnewsinit    : string;  { %s News senden }
function res_getnewsinit     : string;  { %s News holen }
function res_setnewsgroup    : string;  { Newsgroup %s (%d von %d) }
function res_getposting      : string;  { Hole Artikel %d bis %d von %d }
function res_nolastinfo      : string;  { Server bietet weder LAST noch UIDL }
function res_smtpinit        : string;  { %s Mails verschicken }
function res_pop3init        : string;  { %s Mails holen }
function res_IMAPinit        : string;  { %s Mails holen }
function res_mailstat        : string;  { %d (%d neue) Mails in %d Bytes }
function res_getmail         : string;  { Hole Mail Nr. %d }
function res_mailtolarge     : string;  { Mail Nr. %d ist zu gross und wurde uebersprungen }
function res_mailstat_imap   : string;  { %d (%d neue) Mails }
function res_getheader       : string;  { Hole Header %d bis %d von %d }
function res_nntp_incoming   : string;  { eingehende Nachrichten gesamt: %d }
function res_msg_not_avail   : string;  { Mail nicht mehr auf Server vorhanden } 


implementation

uses
  resource;

const
  id_ncresource           = 31100;

  id_res_connect1         = 1 ; 
  id_res_connect2         = 2 ; 
  id_res_connect3         = 3 ; 
  id_res_connect4         = 4 ;
  id_res_disconnect       = 5 ; 
  id_res_error            = 6 ; 
  id_res_noconnect        = 7 ; 
  id_res_userbreak        = 8 ; 
  id_res_strange          = 9 ; 
  id_res_posterror        = 10; 
  id_res_postmsg          = 11; 
  id_res_auth             = 12; 
  id_res_list1            = 13; 
  id_res_list2            = 14; 
  id_res_list3            = 15; 
  id_res_list4            = 16; 
  id_res_list5            = 17; 
  id_res_groupnotfound    = 18; 
  id_res_msg1             = 19;
  id_res_msg2             = 20;
  id_res_msg3             = 21;
  id_res_msg4             = 22;
  id_res_getgrouplistinit = 23;
  id_res_postnewsinit     = 24;
  id_res_getnewsinit      = 25;
  id_res_setnewsgroup     = 26;
  id_res_getposting       = 27;
  id_res_nolastinfo       = 28;
  id_res_smtpinit         = 29;
  id_res_pop3init         = 30;
  id_res_IMAPinit         = 31;
  id_res_mailstat         = 32;
  id_res_getmail          = 33;
  id_res_mailtolarge      = 34;
  id_res_mailstat_imap    = 35;
  id_res_getheader        = 36;
  id_res_nntp_incoming    = 37;
  id_res_msg_not_avail    = 38;

function res_connect1        : string; begin result := getres2(id_ncresource,id_res_connect1        ); end;
function res_connect2        : string; begin result := getres2(id_ncresource,id_res_connect2        ); end;
function res_connect3        : string; begin result := getres2(id_ncresource,id_res_connect3        ); end;
function res_connect4        : string; begin result := getres2(id_ncresource,id_res_connect4        ); end;
function res_disconnect      : string; begin result := getres2(id_ncresource,id_res_disconnect      ); end;
function res_error           : string; begin result := getres2(id_ncresource,id_res_error           ); end;
function res_noconnect       : string; begin result := getres2(id_ncresource,id_res_noconnect       ); end;
function res_userbreak       : string; begin result := getres2(id_ncresource,id_res_userbreak       ); end;
function res_strange         : string; begin result := getres2(id_ncresource,id_res_strange         ); end;
function res_posterror       : string; begin result := getres2(id_ncresource,id_res_posterror       ); end;
function res_postmsg         : string; begin result := getres2(id_ncresource,id_res_postmsg         ); end;
function res_auth            : string; begin result := getres2(id_ncresource,id_res_auth            ); end;
function res_list1           : string; begin result := getres2(id_ncresource,id_res_list1           ); end;
function res_list2           : string; begin result := getres2(id_ncresource,id_res_list2           ); end;
function res_list3           : string; begin result := getres2(id_ncresource,id_res_list3           ); end;
function res_list4           : string; begin result := getres2(id_ncresource,id_res_list4           ); end;
function res_list5           : string; begin result := getres2(id_ncresource,id_res_list5           ); end;
function res_groupnotfound   : string; begin result := getres2(id_ncresource,id_res_groupnotfound   ); end;
function res_msg1            : string; begin result := getres2(id_ncresource,id_res_msg1            ); end;
function res_msg2            : string; begin result := getres2(id_ncresource,id_res_msg2            ); end;
function res_msg3            : string; begin result := getres2(id_ncresource,id_res_msg3            ); end;
function res_msg4            : string; begin result := getres2(id_ncresource,id_res_msg4            ); end;
function res_getgrouplistinit: string; begin result := getres2(id_ncresource,id_res_getgrouplistinit); end;
function res_postnewsinit    : string; begin result := getres2(id_ncresource,id_res_postnewsinit    ); end;
function res_getnewsinit     : string; begin result := getres2(id_ncresource,id_res_getnewsinit     ); end;
function res_setnewsgroup    : string; begin result := getres2(id_ncresource,id_res_setnewsgroup    ); end;
function res_getposting      : string; begin result := getres2(id_ncresource,id_res_getposting      ); end;
function res_nolastinfo      : string; begin result := getres2(id_ncresource,id_res_nolastinfo      ); end;
function res_smtpinit        : string; begin result := getres2(id_ncresource,id_res_smtpinit        ); end;
function res_pop3init        : string; begin result := getres2(id_ncresource,id_res_pop3init        ); end;
function res_IMAPinit        : string; begin result := getres2(id_ncresource,id_res_IMAPinit        ); end;
function res_mailstat        : string; begin result := getres2(id_ncresource,id_res_mailstat        ); end;
function res_getmail         : string; begin result := getres2(id_ncresource,id_res_getmail         ); end;
function res_mailtolarge     : string; begin result := getres2(id_ncresource,id_res_mailtolarge     ); end;
function res_mailstat_imap   : string; begin result := getres2(id_ncresource,id_res_mailstat_imap   ); end;
function res_getheader       : string; begin result := getres2(id_ncresource,id_res_getheader       ); end;
function res_nntp_incoming   : string; begin result := getres2(id_ncresource,id_res_nntp_incoming   ); end;
function res_msg_not_avail   : string; begin result := getres2(id_ncresource,id_res_msg_not_avail   ); end;


end.